export declare const NODE_ARRAY_TYPE = -1;
export declare const NODE_MAP_TYPE = -2;
export declare type JsonPatchOp = "replace" | "add" | "remove";
export interface IJsonPatch {
    op: JsonPatchOp;
    path: string;
    value?: any;
}
export interface IReversibleJsonPatch extends IJsonPatch {
    oldValue?: any;
}
export interface ISchema {
    types: SchemaType[];
    nodes: SchemaNode[];
}
export declare type SchemaType = [string, ...string[]];
export interface ISchemaType {
    name: string;
    props: string[];
}
export declare const schemaType: (type?: SchemaType) => ISchemaType;
export declare type SchemaNode = [number, number, number, number | string, ...string[]];
export interface ISchemaNode {
    id: number;
    type: number;
    parent: number;
    index: number;
    items: string[];
    ref: SchemaNode;
}
export declare const schemaNode: (node?: SchemaNode) => ISchemaNode;
export declare type SchemaPatch = [number, number, number, any?, any?];
export interface ISchemaPatch {
    op: number;
    id: number;
    prop: number;
    values: any[];
}
export declare const schemaPatch: (patch?: SchemaPatch) => ISchemaPatch;
export declare const check: (condition: any, error: string) => void;
