/// <reference types="node" />
import { ISchema, SchemaPatch, IJsonPatch, IReversibleJsonPatch } from "./common";
import { Schema } from "./schema";
export declare class PatchPack {
    schema: Schema;
    constructor(schema?: ISchema);
    encodeSchema(): Buffer;
    decodeSchema(buffer: Buffer): ISchema;
    encodeSchemaPatch(patch: IJsonPatch): Buffer;
    private encodeNode;
    encodeSnapshot(snapshot: any, nodeId?: number): Buffer;
    encodePatch(patch: IReversibleJsonPatch): Buffer;
    decodeSchemaPatch(sp: SchemaPatch): IJsonPatch;
    private decodeNode;
    decodeSnapshot<T = any>(buffer: Buffer, nodeId?: number): T;
    decodePatch(buffer: Buffer, updateSchema?: boolean): any;
}
