import { ISchema, SchemaNode, ISchemaNode, SchemaType, IJsonPatch } from "./common";
export declare class Schema {
    types: SchemaType[];
    nodes: SchemaNode[];
    nextId: number;
    constructor(schema?: ISchema);
    applyPatch(patch: IJsonPatch): IJsonPatch;
    buildFrom(value: any): IJsonPatch[];
    addNodeFrom(value: any, path: string): IJsonPatch[];
    deleteNode(path: string): IJsonPatch;
    addType(name: string, props: string[]): IJsonPatch;
    addTypes(types: {
        [type: string]: string[];
    }): IJsonPatch[];
    nodesAddArray(nodeId: number, parentId: number, name: number | string): IJsonPatch;
    nodesAddMap(nodeId: number, parentId: number, name: number | string, keys?: string[]): IJsonPatch;
    nodesAddObject(nodeId: number, type: string, parentId: number, name: number | string): IJsonPatch;
    nodesAdd(nodeId: number, type: number, parentId: number, name: number | string, keys?: string[]): IJsonPatch;
    nodesAddMapKey(nodeId: number, key: string): IJsonPatch;
    nodesDelete(nodeId: number, deleteChildren?: boolean): IJsonPatch;
    getTypeProps(index: number): string[];
    getNodeName(sn: SchemaNode | ISchemaNode): string | number;
    getNodeIndex(parentId: number, name: string): number;
    getNode(nodeId: number): ISchemaNode | undefined;
    getNodePath(sn: SchemaNode | ISchemaNode): string;
    getChildNode(sn: SchemaNode | ISchemaNode | undefined, name: string | number): ISchemaNode | undefined;
    findNode(query: {
        [key: string]: any;
    }): ISchemaNode | undefined;
    private findType;
    private createNode;
    private add;
    private replace;
    private remove;
}
